-- 29fct520 multilevel pipeline register with oe
library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

entity r29520 is
generic ( tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC;
        output : out STD_LOGIC;
		i,s : in std_logic_vector(1 downto 0);
        not_en: in STD_LOGIC
    );
end r29520;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture r29520_arch of r29520 is
-- don't initialize if u want the check for undefined
signal a1,a2,b1,b2 : std_logic :='0';
begin

proc_ck: process (ck,input,a1,a2,b1,b2,i)
begin
CASE i IS
    WHEN "00" =>
      if (rising_edge(ck)) then
        a1 <= input after tDQ;
      else
        a1 <= a1;
      end if;
      if (rising_edge(ck)) then
        a2 <= a1 after tDQ;
      else
        a2 <= a2;
      end if;
      if (rising_edge(ck)) then
        b1 <= a2 after tDQ;
      else
        b1 <= b1;
      end if;
      if (rising_edge(ck)) then
        b2 <= b1 after tDQ;
      else
        b2 <= b2;
      end if;
    WHEN "01" =>
      if (rising_edge(ck)) then
        b1 <= input after tDQ;
      else
        b1 <= b1;
      end if;
      if (rising_edge(ck)) then
        b2 <= b1 after tDQ;
      else
        b2 <= b2;
      end if;
    WHEN "10" =>
      if (rising_edge(ck)) then
        a1 <= input after tDQ;
      else
        a1 <= a1;
      end if;
      if (rising_edge(ck)) then
        a2 <= a1 after tDQ;
      else
        a2 <= a2;
      end if;
    WHEN OTHERS =>
END CASE;        
end process proc_ck;

proc_en: process (not_en,a1,a2,b1,b2,s)
begin
if (not_en='0') then
CASE s IS
    WHEN "00" =>
      output <= b2 after tAC;
    WHEN "01" =>
      output <= b1 after tAC;
    WHEN "10" =>
      output <= a2 after tAC;
    WHEN "11" =>
      output <= a1 after tAC;
    WHEN OTHERS =>
END CASE;        
else
  output <= 'Z' after tAC;
end if;
end process proc_en;

end r29520_arch;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;


entity r29520n is
generic ( size : integer :=8; tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC_vector(size-1 downto 0);
        output : out STD_LOGIC_vector(size-1 downto 0);
		i,s : in std_logic_vector(1 downto 0);
        not_en: in STD_LOGIC
    );
end r29520n;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture r29520n_arch of r29520n is
-- Component instantiated by Turbo autoplace on 11/20/95 at 13:17:23
COMPONENT r29520
generic ( tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC;
        output : out STD_LOGIC;
		i,s : in std_logic_vector(1 downto 0);
        not_en: in STD_LOGIC
    );
END COMPONENT;
begin

c_call: FOR j IN 0 TO size-1 GENERATE
          bits: r29520
          generic map (tAC => tAC, tDQ => tDQ) 
          port map (ck => ck, input => input(j), output => output(j), not_en => not_en, i=>i, s=>s);
        END GENERATE;    
end r29520N_arch;
